package hero.util;

import java.io.Serializable;

import javax.mail.Address;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

public final class MailNotification implements Serializable, java.lang.Cloneable {

	 private Session session;
   
	 public void initMailService()
	 {
	    try {
			BonitaServiceLocator serviceLocator = BonitaServiceLocator.getInstance();
			session = (Session) serviceLocator.getMailSession(BonitaServiceLocator.Services.MAIL_SERVICE);
	    } catch (BonitaServiceException e) {
		   e.printStackTrace();
	    }
	 }
    
	 public void sendMail(String toAccount, String title,String body) throws Exception {
	 try {
	 	this.initMailService();
	 	
		 MimeMessage m = new MimeMessage(session);
		 m.setFrom();
		 Address[] to = new InternetAddress[] {new InternetAddress(toAccount) };
		 m.setRecipients(javax.mail.Message.RecipientType.TO, to);
		 m.setSubject(title);
		 m.setSentDate(new java.util.Date());
		 m.setContent(body,"text/plain");
		 Transport.send(m);
	 } catch (javax.mail.MessagingException e) {
		 System.out.println("mail-service.xml configuration error: "+e);
	 }                
	 }

	public MailNotification(){}
	
    public Object clone() throws java.lang.CloneNotSupportedException{
	return super.clone();
    }

}
