package hero.mapper;

import hero.util.HeroException;
import hero.interfaces.BnRoleLocal;

// Use of BnLdap session Bean
import hero.interfaces.BnLdap;
import hero.interfaces.BnLdapHome;
import hero.interfaces.BnLdapUtil;

// use of the ProjectSession Bean
import hero.interfaces.ProjectSessionLocalHome;
import hero.interfaces.ProjectSessionLocal;
import hero.interfaces.ProjectSessionUtil;

import java.util.*;


public class LdapGroupMembers implements hero.mapper.RoleMapperI {

    public void searchMembers(Object b,BnRoleLocal n, String userName) throws HeroException {
	
	    String roleName=n.getName();
	    String projectName=n.getBnProject().getName();	    
	    System.out.println("[Search Group Members] BnRole name:"+roleName + " - Project name = " + projectName);
		ArrayList al =null;
		
		BnLdapHome home = null;
		try {
			home = BnLdapUtil.getHome();		      
		} catch (Exception e) {
		    System.err.println( "Cannot lookup BnLdapHome: " + e);
		    System.exit(2);
		}
	
		BnLdap t1 = null;
		try {
			// logs trace
		    System.out.println("Create a bean bnLdap");
		    t1 = home.create();
		} catch (Exception e) {
			throw new HeroException("Cannot create  BnLdapBean : " + e);
		}
		try {
		al = (ArrayList)t1.getGroupMembers(roleName);
		} catch (Exception e){
			throw new HeroException("Error getting group members for group: " + roleName + " " + e.getMessage());
		}
		try {
	
		if (al.size() != 0){

			ProjectSessionLocalHome projecth = (ProjectSessionLocalHome)ProjectSessionUtil.getLocalHome();
			ProjectSessionLocal projectsession = projecth.create();
			projectsession.initProject(projectName);		
			Iterator it = al.iterator();
			while (it.hasNext()){
				String userUid = (String)it.next();
				
				// add user to the project  instance (but not for the project model)
				projectsession.addUser(userUid);
				
				// logs trace
				System.out.println("Add user: " + userUid + " to project: " + projectName );
				
				// set the user role
				projectsession.setUserRole(userUid, roleName);
				// logs trace
				System.out.println("Set role: " + roleName + " to user: " + userUid );
			}
			projectsession.remove();
		}
		else {
			// log trace
			System.out.println("Warning: no members found in LDAP group: " + roleName);
		}
		
		} catch (Exception e) {		    
			throw new HeroException("Error setting role : " + roleName + " with mapper " + e.getMessage());
		}	
		
		try {
		    t1.remove();
		} catch (Exception e) {
			throw new HeroException("Error on removing BnLdapBean: "+e);
		}
	    
    } 

}















